# coding: utf-8

# flake8: noqa

"""
    PortainerCE API

    Portainer API is an HTTP API served by Portainer. It is used by the Portainer UI and everything you can do with the UI can be done using the HTTP API. Examples are available at https://documentation.portainer.io/api/api-examples/ You can find out more about Portainer at [http://portainer.io](http://portainer.io) and get some support on [Slack](http://portainer.io/slack/).  # Authentication  Most of the API endpoints require to be authenticated as well as some level of authorization to be used. Portainer API uses JSON Web Token to manage authentication and thus requires you to provide a token in the **Authorization** header of each request with the **Bearer** authentication mechanism.  Example:  ``` Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpZCI6MSwidXNlcm5hbWUiOiJhZG1pbiIsInJvbGUiOjEsImV4cCI6MTQ5OTM3NjE1NH0.NJ6vE8FY1WG6jsRQzfMqeatJ4vh2TWAeeYfDhP71YEE ```  # Security  Each API endpoint has an associated access policy, it is documented in the description of each endpoint.  Different access policies are available:  - Public access - Authenticated access - Restricted access - Administrator access  ### Public access  No authentication is required to access the endpoints with this access policy.  ### Authenticated access  Authentication is required to access the endpoints with this access policy.  ### Restricted access  Authentication is required to access the endpoints with this access policy. Extra-checks might be added to ensure access to the resource is granted. Returned data might also be filtered.  ### Administrator access  Authentication as well as an administrator role are required to access the endpoints with this access policy.  # Execute Docker requests  Portainer **DOES NOT** expose specific endpoints to manage your Docker resources (create a container, remove a volume, etc...).  Instead, it acts as a reverse-proxy to the Docker HTTP API. This means that you can execute Docker requests **via** the Portainer HTTP API.  To do so, you can use the `/endpoints/{id}/docker` Portainer API endpoint (which is not documented below due to Swagger limitations). This endpoint has a restricted access policy so you still need to be authenticated to be able to query this endpoint. Any query on this endpoint will be proxied to the Docker API of the associated endpoint (requests and responses objects are the same as documented in the Docker API).  **NOTE**: You can find more information on how to query the Docker API in the [Docker official documentation](https://docs.docker.com/engine/api/v1.30/) as well as in [this Portainer example](https://documentation.portainer.io/api/api-examples/).   # noqa: E501

    OpenAPI spec version: 2.6.0
    Contact: info@portainer.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# import apis into sdk package
from portainer_ce_api.api.default_api import DefaultApi
from portainer_ce_api.api.auth_api import AuthApi
from portainer_ce_api.api.backup_api import BackupApi
from portainer_ce_api.api.custom_templates_api import CustomTemplatesApi
from portainer_ce_api.api.dockerhub_api import DockerhubApi
from portainer_ce_api.api.edge_api import EdgeApi
from portainer_ce_api.api.edge_groups_api import EdgeGroupsApi
from portainer_ce_api.api.edge_jobs_api import EdgeJobsApi
from portainer_ce_api.api.edge_stacks_api import EdgeStacksApi
from portainer_ce_api.api.edge_templates_api import EdgeTemplatesApi
from portainer_ce_api.api.endpoint_groups_api import EndpointGroupsApi
from portainer_ce_api.api.endpoints_api import EndpointsApi
from portainer_ce_api.api.motd_api import MotdApi
from portainer_ce_api.api.registries_api import RegistriesApi
from portainer_ce_api.api.resource_controls_api import ResourceControlsApi
from portainer_ce_api.api.roles_api import RolesApi
from portainer_ce_api.api.settings_api import SettingsApi
from portainer_ce_api.api.stacks_api import StacksApi
from portainer_ce_api.api.status_api import StatusApi
from portainer_ce_api.api.tags_api import TagsApi
from portainer_ce_api.api.team_memberships_api import TeamMembershipsApi
from portainer_ce_api.api.teams_api import TeamsApi
from portainer_ce_api.api.templates_api import TemplatesApi
from portainer_ce_api.api.upload_api import UploadApi
from portainer_ce_api.api.users_api import UsersApi
from portainer_ce_api.api.webhooks_api import WebhooksApi
from portainer_ce_api.api.websocket_api import WebsocketApi

# import ApiClient
from portainer_ce_api.api_client import ApiClient
from portainer_ce_api.configuration import Configuration
# import models into sdk package
from portainer_ce_api.models.auth_authenticate_payload import AuthAuthenticatePayload
from portainer_ce_api.models.auth_authenticate_response import AuthAuthenticateResponse
from portainer_ce_api.models.auth_oauth_payload import AuthOauthPayload
from portainer_ce_api.models.customtemplates_custom_template_from_file_content_payload import CustomtemplatesCustomTemplateFromFileContentPayload
from portainer_ce_api.models.customtemplates_custom_template_from_git_repository_payload import CustomtemplatesCustomTemplateFromGitRepositoryPayload
from portainer_ce_api.models.customtemplates_custom_template_update_payload import CustomtemplatesCustomTemplateUpdatePayload
from portainer_ce_api.models.customtemplates_file_response import CustomtemplatesFileResponse
from portainer_ce_api.models.dockerhub_dockerhub_update_payload import DockerhubDockerhubUpdatePayload
from portainer_ce_api.models.edgegroups_edge_group_create_payload import EdgegroupsEdgeGroupCreatePayload
from portainer_ce_api.models.edgegroups_edge_group_update_payload import EdgegroupsEdgeGroupUpdatePayload
from portainer_ce_api.models.edgejobs_edge_job_create_from_file_content_payload import EdgejobsEdgeJobCreateFromFileContentPayload
from portainer_ce_api.models.edgejobs_edge_job_create_from_file_payload import EdgejobsEdgeJobCreateFromFilePayload
from portainer_ce_api.models.edgejobs_edge_job_file_response import EdgejobsEdgeJobFileResponse
from portainer_ce_api.models.edgejobs_edge_job_update_payload import EdgejobsEdgeJobUpdatePayload
from portainer_ce_api.models.edgejobs_file_response import EdgejobsFileResponse
from portainer_ce_api.models.edgejobs_task_container import EdgejobsTaskContainer
from portainer_ce_api.models.edgestacks_stack_file_response import EdgestacksStackFileResponse
from portainer_ce_api.models.edgestacks_swarm_stack_from_file_content_payload import EdgestacksSwarmStackFromFileContentPayload
from portainer_ce_api.models.edgestacks_swarm_stack_from_file_upload_payload import EdgestacksSwarmStackFromFileUploadPayload
from portainer_ce_api.models.edgestacks_swarm_stack_from_git_repository_payload import EdgestacksSwarmStackFromGitRepositoryPayload
from portainer_ce_api.models.edgestacks_update_edge_stack_payload import EdgestacksUpdateEdgeStackPayload
from portainer_ce_api.models.endpointedge_config_response import EndpointedgeConfigResponse
from portainer_ce_api.models.endpointgroups_endpoint_group_create_payload import EndpointgroupsEndpointGroupCreatePayload
from portainer_ce_api.models.endpointgroups_endpoint_group_update_payload import EndpointgroupsEndpointGroupUpdatePayload
from portainer_ce_api.models.endpoints_edge_job_response import EndpointsEdgeJobResponse
from portainer_ce_api.models.endpoints_endpoint_settings_update_payload import EndpointsEndpointSettingsUpdatePayload
from portainer_ce_api.models.endpoints_endpoint_status_inspect_response import EndpointsEndpointStatusInspectResponse
from portainer_ce_api.models.endpoints_endpoint_update_payload import EndpointsEndpointUpdatePayload
from portainer_ce_api.models.endpoints_stack_status_response import EndpointsStackStatusResponse
from portainer_ce_api.models.gittypes_repo_config import GittypesRepoConfig
from portainer_ce_api.models.motd_motd_response import MotdMotdResponse
from portainer_ce_api.models.portainer_access_policy import PortainerAccessPolicy
from portainer_ce_api.models.portainer_authorizations import PortainerAuthorizations
from portainer_ce_api.models.portainer_azure_credentials import PortainerAzureCredentials
from portainer_ce_api.models.portainer_custom_template import PortainerCustomTemplate
from portainer_ce_api.models.portainer_docker_hub import PortainerDockerHub
from portainer_ce_api.models.portainer_docker_snapshot import PortainerDockerSnapshot
from portainer_ce_api.models.portainer_docker_snapshot_raw import PortainerDockerSnapshotRaw
from portainer_ce_api.models.portainer_edge_group import PortainerEdgeGroup
from portainer_ce_api.models.portainer_edge_job import PortainerEdgeJob
from portainer_ce_api.models.portainer_edge_job_endpoint_meta import PortainerEdgeJobEndpointMeta
from portainer_ce_api.models.portainer_edge_stack import PortainerEdgeStack
from portainer_ce_api.models.portainer_edge_stack_status import PortainerEdgeStackStatus
from portainer_ce_api.models.portainer_endpoint import PortainerEndpoint
from portainer_ce_api.models.portainer_endpoint_authorizations import PortainerEndpointAuthorizations
from portainer_ce_api.models.portainer_endpoint_extension import PortainerEndpointExtension
from portainer_ce_api.models.portainer_endpoint_group import PortainerEndpointGroup
from portainer_ce_api.models.portainer_endpoint_security_settings import PortainerEndpointSecuritySettings
from portainer_ce_api.models.portainer_gitlab_registry_data import PortainerGitlabRegistryData
from portainer_ce_api.models.portainer_kubernetes_configuration import PortainerKubernetesConfiguration
from portainer_ce_api.models.portainer_kubernetes_data import PortainerKubernetesData
from portainer_ce_api.models.portainer_kubernetes_ingress_class_config import PortainerKubernetesIngressClassConfig
from portainer_ce_api.models.portainer_kubernetes_snapshot import PortainerKubernetesSnapshot
from portainer_ce_api.models.portainer_kubernetes_storage_class_config import PortainerKubernetesStorageClassConfig
from portainer_ce_api.models.portainer_ldap_group_search_settings import PortainerLDAPGroupSearchSettings
from portainer_ce_api.models.portainer_ldap_search_settings import PortainerLDAPSearchSettings
from portainer_ce_api.models.portainer_ldap_settings import PortainerLDAPSettings
from portainer_ce_api.models.portainer_o_auth_settings import PortainerOAuthSettings
from portainer_ce_api.models.portainer_pair import PortainerPair
from portainer_ce_api.models.portainer_quay_registry_data import PortainerQuayRegistryData
from portainer_ce_api.models.portainer_registry import PortainerRegistry
from portainer_ce_api.models.portainer_registry_management_configuration import PortainerRegistryManagementConfiguration
from portainer_ce_api.models.portainer_resource_control import PortainerResourceControl
from portainer_ce_api.models.portainer_role import PortainerRole
from portainer_ce_api.models.portainer_settings import PortainerSettings
from portainer_ce_api.models.portainer_stack import PortainerStack
from portainer_ce_api.models.portainer_status import PortainerStatus
from portainer_ce_api.models.portainer_tls_configuration import PortainerTLSConfiguration
from portainer_ce_api.models.portainer_tag import PortainerTag
from portainer_ce_api.models.portainer_team import PortainerTeam
from portainer_ce_api.models.portainer_team_access_policies import PortainerTeamAccessPolicies
from portainer_ce_api.models.portainer_team_membership import PortainerTeamMembership
from portainer_ce_api.models.portainer_team_resource_access import PortainerTeamResourceAccess
from portainer_ce_api.models.portainer_template import PortainerTemplate
from portainer_ce_api.models.portainer_template_env import PortainerTemplateEnv
from portainer_ce_api.models.portainer_template_env_select import PortainerTemplateEnvSelect
from portainer_ce_api.models.portainer_template_repository import PortainerTemplateRepository
from portainer_ce_api.models.portainer_template_volume import PortainerTemplateVolume
from portainer_ce_api.models.portainer_user import PortainerUser
from portainer_ce_api.models.portainer_user_access_policies import PortainerUserAccessPolicies
from portainer_ce_api.models.portainer_user_resource_access import PortainerUserResourceAccess
from portainer_ce_api.models.portainer_webhook import PortainerWebhook
from portainer_ce_api.models.registries_registry_configure_payload import RegistriesRegistryConfigurePayload
from portainer_ce_api.models.registries_registry_create_payload import RegistriesRegistryCreatePayload
from portainer_ce_api.models.registries_registry_update_payload import RegistriesRegistryUpdatePayload
from portainer_ce_api.models.resourcecontrols_resource_control_create_payload import ResourcecontrolsResourceControlCreatePayload
from portainer_ce_api.models.resourcecontrols_resource_control_update_payload import ResourcecontrolsResourceControlUpdatePayload
from portainer_ce_api.models.settings_public_settings_response import SettingsPublicSettingsResponse
from portainer_ce_api.models.settings_settings_ldap_check_payload import SettingsSettingsLDAPCheckPayload
from portainer_ce_api.models.settings_settings_update_payload import SettingsSettingsUpdatePayload
from portainer_ce_api.models.stacks_compose_stack_from_file_content_payload import StacksComposeStackFromFileContentPayload
from portainer_ce_api.models.stacks_compose_stack_from_git_repository_payload import StacksComposeStackFromGitRepositoryPayload
from portainer_ce_api.models.stacks_stack_file_response import StacksStackFileResponse
from portainer_ce_api.models.stacks_stack_migrate_payload import StacksStackMigratePayload
from portainer_ce_api.models.stacks_swarm_stack_from_file_content_payload import StacksSwarmStackFromFileContentPayload
from portainer_ce_api.models.stacks_swarm_stack_from_git_repository_payload import StacksSwarmStackFromGitRepositoryPayload
from portainer_ce_api.models.stacks_update_swarm_stack_payload import StacksUpdateSwarmStackPayload
from portainer_ce_api.models.status_inspect_version_response import StatusInspectVersionResponse
from portainer_ce_api.models.tags_tag_create_payload import TagsTagCreatePayload
from portainer_ce_api.models.teammemberships_team_membership_create_payload import TeammembershipsTeamMembershipCreatePayload
from portainer_ce_api.models.teammemberships_team_membership_update_payload import TeammembershipsTeamMembershipUpdatePayload
from portainer_ce_api.models.teams_team_create_payload import TeamsTeamCreatePayload
from portainer_ce_api.models.teams_team_update_payload import TeamsTeamUpdatePayload
from portainer_ce_api.models.templates_file_payload import TemplatesFilePayload
from portainer_ce_api.models.templates_file_response import TemplatesFileResponse
from portainer_ce_api.models.templates_list_response import TemplatesListResponse
from portainer_ce_api.models.users_admin_init_payload import UsersAdminInitPayload
from portainer_ce_api.models.users_user_create_payload import UsersUserCreatePayload
from portainer_ce_api.models.users_user_update_password_payload import UsersUserUpdatePasswordPayload
from portainer_ce_api.models.users_user_update_payload import UsersUserUpdatePayload
from portainer_ce_api.models.webhooks_webhook_create_payload import WebhooksWebhookCreatePayload
