# coding: utf-8

"""
    PortainerCE API

    Portainer API is an HTTP API served by Portainer. It is used by the Portainer UI and everything you can do with the UI can be done using the HTTP API. Examples are available at https://documentation.portainer.io/api/api-examples/ You can find out more about Portainer at [http://portainer.io](http://portainer.io) and get some support on [Slack](http://portainer.io/slack/).  # Authentication  Most of the API endpoints require to be authenticated as well as some level of authorization to be used. Portainer API uses JSON Web Token to manage authentication and thus requires you to provide a token in the **Authorization** header of each request with the **Bearer** authentication mechanism.  Example:  ``` Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpZCI6MSwidXNlcm5hbWUiOiJhZG1pbiIsInJvbGUiOjEsImV4cCI6MTQ5OTM3NjE1NH0.NJ6vE8FY1WG6jsRQzfMqeatJ4vh2TWAeeYfDhP71YEE ```  # Security  Each API endpoint has an associated access policy, it is documented in the description of each endpoint.  Different access policies are available:  - Public access - Authenticated access - Restricted access - Administrator access  ### Public access  No authentication is required to access the endpoints with this access policy.  ### Authenticated access  Authentication is required to access the endpoints with this access policy.  ### Restricted access  Authentication is required to access the endpoints with this access policy. Extra-checks might be added to ensure access to the resource is granted. Returned data might also be filtered.  ### Administrator access  Authentication as well as an administrator role are required to access the endpoints with this access policy.  # Execute Docker requests  Portainer **DOES NOT** expose specific endpoints to manage your Docker resources (create a container, remove a volume, etc...).  Instead, it acts as a reverse-proxy to the Docker HTTP API. This means that you can execute Docker requests **via** the Portainer HTTP API.  To do so, you can use the `/endpoints/{id}/docker` Portainer API endpoint (which is not documented below due to Swagger limitations). This endpoint has a restricted access policy so you still need to be authenticated to be able to query this endpoint. Any query on this endpoint will be proxied to the Docker API of the associated endpoint (requests and responses objects are the same as documented in the Docker API).  **NOTE**: You can find more information on how to query the Docker API in the [Docker official documentation](https://docs.docker.com/engine/api/v1.30/) as well as in [this Portainer example](https://documentation.portainer.io/api/api-examples/).   # noqa: E501

    OpenAPI spec version: 2.6.0
    Contact: info@portainer.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from portainer_ce_api.configuration import Configuration


class PortainerDockerSnapshotRaw(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'containers': 'object',
        'images': 'object',
        'info': 'object',
        'networks': 'object',
        'version': 'object',
        'volumes': 'object'
    }

    attribute_map = {
        'containers': 'Containers',
        'images': 'Images',
        'info': 'Info',
        'networks': 'Networks',
        'version': 'Version',
        'volumes': 'Volumes'
    }

    def __init__(self, containers=None, images=None, info=None, networks=None, version=None, volumes=None, _configuration=None):  # noqa: E501
        """PortainerDockerSnapshotRaw - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._containers = None
        self._images = None
        self._info = None
        self._networks = None
        self._version = None
        self._volumes = None
        self.discriminator = None

        if containers is not None:
            self.containers = containers
        if images is not None:
            self.images = images
        if info is not None:
            self.info = info
        if networks is not None:
            self.networks = networks
        if version is not None:
            self.version = version
        if volumes is not None:
            self.volumes = volumes

    @property
    def containers(self):
        """Gets the containers of this PortainerDockerSnapshotRaw.  # noqa: E501


        :return: The containers of this PortainerDockerSnapshotRaw.  # noqa: E501
        :rtype: object
        """
        return self._containers

    @containers.setter
    def containers(self, containers):
        """Sets the containers of this PortainerDockerSnapshotRaw.


        :param containers: The containers of this PortainerDockerSnapshotRaw.  # noqa: E501
        :type: object
        """

        self._containers = containers

    @property
    def images(self):
        """Gets the images of this PortainerDockerSnapshotRaw.  # noqa: E501


        :return: The images of this PortainerDockerSnapshotRaw.  # noqa: E501
        :rtype: object
        """
        return self._images

    @images.setter
    def images(self, images):
        """Sets the images of this PortainerDockerSnapshotRaw.


        :param images: The images of this PortainerDockerSnapshotRaw.  # noqa: E501
        :type: object
        """

        self._images = images

    @property
    def info(self):
        """Gets the info of this PortainerDockerSnapshotRaw.  # noqa: E501


        :return: The info of this PortainerDockerSnapshotRaw.  # noqa: E501
        :rtype: object
        """
        return self._info

    @info.setter
    def info(self, info):
        """Sets the info of this PortainerDockerSnapshotRaw.


        :param info: The info of this PortainerDockerSnapshotRaw.  # noqa: E501
        :type: object
        """

        self._info = info

    @property
    def networks(self):
        """Gets the networks of this PortainerDockerSnapshotRaw.  # noqa: E501


        :return: The networks of this PortainerDockerSnapshotRaw.  # noqa: E501
        :rtype: object
        """
        return self._networks

    @networks.setter
    def networks(self, networks):
        """Sets the networks of this PortainerDockerSnapshotRaw.


        :param networks: The networks of this PortainerDockerSnapshotRaw.  # noqa: E501
        :type: object
        """

        self._networks = networks

    @property
    def version(self):
        """Gets the version of this PortainerDockerSnapshotRaw.  # noqa: E501


        :return: The version of this PortainerDockerSnapshotRaw.  # noqa: E501
        :rtype: object
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this PortainerDockerSnapshotRaw.


        :param version: The version of this PortainerDockerSnapshotRaw.  # noqa: E501
        :type: object
        """

        self._version = version

    @property
    def volumes(self):
        """Gets the volumes of this PortainerDockerSnapshotRaw.  # noqa: E501


        :return: The volumes of this PortainerDockerSnapshotRaw.  # noqa: E501
        :rtype: object
        """
        return self._volumes

    @volumes.setter
    def volumes(self, volumes):
        """Sets the volumes of this PortainerDockerSnapshotRaw.


        :param volumes: The volumes of this PortainerDockerSnapshotRaw.  # noqa: E501
        :type: object
        """

        self._volumes = volumes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PortainerDockerSnapshotRaw, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PortainerDockerSnapshotRaw):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PortainerDockerSnapshotRaw):
            return True

        return self.to_dict() != other.to_dict()
