# coding: utf-8

"""
    PortainerCE API

    Portainer API is an HTTP API served by Portainer. It is used by the Portainer UI and everything you can do with the UI can be done using the HTTP API. Examples are available at https://documentation.portainer.io/api/api-examples/ You can find out more about Portainer at [http://portainer.io](http://portainer.io) and get some support on [Slack](http://portainer.io/slack/).  # Authentication  Most of the API endpoints require to be authenticated as well as some level of authorization to be used. Portainer API uses JSON Web Token to manage authentication and thus requires you to provide a token in the **Authorization** header of each request with the **Bearer** authentication mechanism.  Example:  ``` Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpZCI6MSwidXNlcm5hbWUiOiJhZG1pbiIsInJvbGUiOjEsImV4cCI6MTQ5OTM3NjE1NH0.NJ6vE8FY1WG6jsRQzfMqeatJ4vh2TWAeeYfDhP71YEE ```  # Security  Each API endpoint has an associated access policy, it is documented in the description of each endpoint.  Different access policies are available:  - Public access - Authenticated access - Restricted access - Administrator access  ### Public access  No authentication is required to access the endpoints with this access policy.  ### Authenticated access  Authentication is required to access the endpoints with this access policy.  ### Restricted access  Authentication is required to access the endpoints with this access policy. Extra-checks might be added to ensure access to the resource is granted. Returned data might also be filtered.  ### Administrator access  Authentication as well as an administrator role are required to access the endpoints with this access policy.  # Execute Docker requests  Portainer **DOES NOT** expose specific endpoints to manage your Docker resources (create a container, remove a volume, etc...).  Instead, it acts as a reverse-proxy to the Docker HTTP API. This means that you can execute Docker requests **via** the Portainer HTTP API.  To do so, you can use the `/endpoints/{id}/docker` Portainer API endpoint (which is not documented below due to Swagger limitations). This endpoint has a restricted access policy so you still need to be authenticated to be able to query this endpoint. Any query on this endpoint will be proxied to the Docker API of the associated endpoint (requests and responses objects are the same as documented in the Docker API).  **NOTE**: You can find more information on how to query the Docker API in the [Docker official documentation](https://docs.docker.com/engine/api/v1.30/) as well as in [this Portainer example](https://documentation.portainer.io/api/api-examples/).   # noqa: E501

    OpenAPI spec version: 2.6.0
    Contact: info@portainer.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from portainer_ce_api.configuration import Configuration


class PortainerKubernetesSnapshot(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'kubernetes_version': 'str',
        'node_count': 'int',
        'time': 'int',
        'total_cpu': 'int',
        'total_memory': 'int'
    }

    attribute_map = {
        'kubernetes_version': 'KubernetesVersion',
        'node_count': 'NodeCount',
        'time': 'Time',
        'total_cpu': 'TotalCPU',
        'total_memory': 'TotalMemory'
    }

    def __init__(self, kubernetes_version=None, node_count=None, time=None, total_cpu=None, total_memory=None, _configuration=None):  # noqa: E501
        """PortainerKubernetesSnapshot - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._kubernetes_version = None
        self._node_count = None
        self._time = None
        self._total_cpu = None
        self._total_memory = None
        self.discriminator = None

        if kubernetes_version is not None:
            self.kubernetes_version = kubernetes_version
        if node_count is not None:
            self.node_count = node_count
        if time is not None:
            self.time = time
        if total_cpu is not None:
            self.total_cpu = total_cpu
        if total_memory is not None:
            self.total_memory = total_memory

    @property
    def kubernetes_version(self):
        """Gets the kubernetes_version of this PortainerKubernetesSnapshot.  # noqa: E501


        :return: The kubernetes_version of this PortainerKubernetesSnapshot.  # noqa: E501
        :rtype: str
        """
        return self._kubernetes_version

    @kubernetes_version.setter
    def kubernetes_version(self, kubernetes_version):
        """Sets the kubernetes_version of this PortainerKubernetesSnapshot.


        :param kubernetes_version: The kubernetes_version of this PortainerKubernetesSnapshot.  # noqa: E501
        :type: str
        """

        self._kubernetes_version = kubernetes_version

    @property
    def node_count(self):
        """Gets the node_count of this PortainerKubernetesSnapshot.  # noqa: E501


        :return: The node_count of this PortainerKubernetesSnapshot.  # noqa: E501
        :rtype: int
        """
        return self._node_count

    @node_count.setter
    def node_count(self, node_count):
        """Sets the node_count of this PortainerKubernetesSnapshot.


        :param node_count: The node_count of this PortainerKubernetesSnapshot.  # noqa: E501
        :type: int
        """

        self._node_count = node_count

    @property
    def time(self):
        """Gets the time of this PortainerKubernetesSnapshot.  # noqa: E501


        :return: The time of this PortainerKubernetesSnapshot.  # noqa: E501
        :rtype: int
        """
        return self._time

    @time.setter
    def time(self, time):
        """Sets the time of this PortainerKubernetesSnapshot.


        :param time: The time of this PortainerKubernetesSnapshot.  # noqa: E501
        :type: int
        """

        self._time = time

    @property
    def total_cpu(self):
        """Gets the total_cpu of this PortainerKubernetesSnapshot.  # noqa: E501


        :return: The total_cpu of this PortainerKubernetesSnapshot.  # noqa: E501
        :rtype: int
        """
        return self._total_cpu

    @total_cpu.setter
    def total_cpu(self, total_cpu):
        """Sets the total_cpu of this PortainerKubernetesSnapshot.


        :param total_cpu: The total_cpu of this PortainerKubernetesSnapshot.  # noqa: E501
        :type: int
        """

        self._total_cpu = total_cpu

    @property
    def total_memory(self):
        """Gets the total_memory of this PortainerKubernetesSnapshot.  # noqa: E501


        :return: The total_memory of this PortainerKubernetesSnapshot.  # noqa: E501
        :rtype: int
        """
        return self._total_memory

    @total_memory.setter
    def total_memory(self, total_memory):
        """Sets the total_memory of this PortainerKubernetesSnapshot.


        :param total_memory: The total_memory of this PortainerKubernetesSnapshot.  # noqa: E501
        :type: int
        """

        self._total_memory = total_memory

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PortainerKubernetesSnapshot, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PortainerKubernetesSnapshot):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PortainerKubernetesSnapshot):
            return True

        return self.to_dict() != other.to_dict()
